/*
 * javascript垃圾回收
 * */
;var GC = (function(){

    //引用地址
    var refs = {},EVENTS = [];

    var purge = function(d) {
        var a = d.attributes, i, l, n;
        if (a) {
            for (i = a.length - 1; i >= 0; i -= 1) {
                n = a[i].name;
                if (typeof d[n] === 'function') {
                    d[n] = null;
                }
            }
        }
        a = d.childNodes;
        if (a) {
            l = a.length;
            for (i = 0; i < l; i += 1) {
                purge(d.childNodes[i]);
            }
        }
    }
     
     function walkTheDOM(node, func) {
        func(node); 
        node = node.firstChild; 
        while (node) { 
            walkTheDOM(node, func); 
            node = node.nextSibling; 
        } 
    } 
    /**
     * 清除dom节点的所有引用，防止内存泄露
     *
     * @param Elem node  所要清除的元素节点
     * 
     */
    function purgeEventHandlers(node) {
        walkTheDOM(node, function (e) {
            for (var n in e) {    

                if (typeof e[n] === 'function') {
                    e[n] = null;
                }
            }
        });
    }

    /*
     * gcArrays 回收的对象
     * modules 回收所属模块
     */
    var push = function (gcArrays, modules , target) {

        var id = $(target).attr("id") || "body";
        if(!refs[id]) refs[id] = {};
        refs[id][modules] = gcArrays.concat(refs[id][modules] || []);
    }

    var get = function (id , modules) {
        if(refs[id]){
            return  refs[id][modules];
        } else{
            return [];
        }
         
    }


    var destroy = function (sectionId) {
        if(refs[sectionId]){
            for(var module in refs[sectionId]){
                for (var i = module.length - 1; i >= 0; i -= 1) {
                    var obj = module[i];
                    obj.destroyMe && obj.destroyMe();
                    obj = null;
                }
            }
            //purgeEventHandlers($(refs[sectionId])[0]);
            $("#" + sectionId).unbind("tap");
            refs[sectionId] = null;
        }
    };

    return {
        purge : purge,
        push : push,
        get : get,
        destroy : destroy,
        refs:refs
    }

})();



 


