;ui.Page = (function(){

 	var _history = [], sectionEventCache = {}, _currentSection = {}, _pageStatus = {},
        //上次section事件
        prevSectionEvent = {
            onReady :null,
            onLoad : null,
            onBack : null 
        };
	var init = function(){
 		var $section = $('#section_container section').first();
        var indexHash = $section.attr('id');
        _add2History({
        	tag : indexHash
        },true);

        app.section = {
            onReady :$.noop,
            onLoad : $.noop,
            onBack : $.noop 
        }

        app.getSectionParams = function(){
            return _currentSection.params;
        }
	}

    var _pageCanSwitch = function (){
        if(ui.isPageSwitching){
            return false;
        } else{
            ui.isPageSwitching = true;
            return true;
        }
    }


	//加载页面
	var load = function(options){

		if(ui.settings.appType == 'single'){
            if(!_pageCanSwitch()) return;

            delete options.progress;
            delete options.slideType;

            if(ui.hasMenuOpen){//关闭菜单后再转场
                ui.Menu.hide(200,function(){
                    _router(options);
                    //_showSection(options, true);
                });  
                return;         
            }
            _router(options);
            //_showSection(options, true);
            
        } else {
        	app.load(options);
        }
	}

   /*
     * 后退
     */
    var back = function(pageNumber){

        if(ui.settings.appType == 'single' && _history.length > 1 ){

            var res =  sectionEventCache[_history[0].tag].onBack && sectionEventCache[_history[0].tag].onBack(_history[0]);
            if(res === false) { return; }
            
            if(ui.hasMenuOpen || !_pageCanSwitch()) return;

            var current = _history.shift();

            //退到某特定页码
            if(pageNumber < _history.length ){ //合理页码 
                var popNumber = _history.length - 1 - pageNumber;
                if(popNumber > 0 ){
                    while(popNumber){
                        var delHistory = _history.shift();
                         GC.destroy(delHistory.tag);//垃圾回收
                        _removeHistoryDom("#"+ delHistory.tag);//清除旧页面DOM
                        popNumber--;
                    }
                }
            }

            _changePage("#"+current.tag, "#"+_history[0].tag,true, true, function(){

                GC.destroy(current.tag);//垃圾回收
                _removeHistoryDom("#"+ current.tag);//清除旧页面DOM
                _resumePageStatus(_history[0].tag); //页面状态恢复
            });

            //$(current.tag).trigger("pageBack", [current]);
            delete sectionEventCache[current.tag];
            _currentSection = _history[0];
        } else{
            app.back();
        }
    }

    /*
      * 刷新
      */
    var refresh = function(){     
        if(ui.settings.appType == 'single' && _history.length > 1 ){
            if(!_pageCanSwitch()) return;
            var current =  _history.shift();
            GC.destroy(current.tag);//垃圾回收
            _showSection(current, false);
        } else {
            app.refresh();
        }
    }

    /*
    * 路由控制
    */
    var _router = function(options){
        var isRemoteUrl = /^https?:\/\//.test(options.url);
        if(isRemoteUrl){
           window.open(options.url,"_blank","location=yes"); //open打开远程页面
           ui.isPageSwitching = false;
        } else {
            _showSection(options, true);
        }
    }


	/*
     * 跳转到新页面
     * @param hash 新page的'#id'
     */
    var _showSection  = function(options, animation){
 	
 	 	var current = _history[0];
    	options.tag = _getTag(options.url);
        options.sectionId = options.tag;
        //同一个页面,则不重新加载
        if(current.tag === options.tag){
            return;
        }
        //加载模板
        loadSectionTpl(options,function(){

            //页面状态保存
           _savePageStatus(current.tag);
            //卡片页跳转动画
           _changePage("#" + current.tag,"#"+ options.tag, false, animation);

           _add2History(options);
           //$(options.tag).trigger('pageLoad', [options]); // 页面动画效果结束
           sectionEventCache[options.tag].onLoad && sectionEventCache[options.tag].onLoad(options);
                

        });
    }

    var _getTag = function(url){
    	var time = new Date().getTime(),
			_dIndex = url.lastIndexOf("."),
    	    _gIndex = url.lastIndexOf("/");
    	if(_dIndex > -1 ){
    		return url.substring(_gIndex + 1, _dIndex) + time;
    	} else{
    		return url.substring(_gIndex + 1) + time;
    	}
    }

    var _changePage = function(current,target,isBack, animation, callback){
        ui.Transition.run(current,target,isBack, animation, callback);
    }

    var _add2History = function(hashObj){
	
		$.each(_history, function(i, page){
			if(page.tag == hashObj.tag){ //如果已存在相同的页面，则把以前的堆栈去掉
 				_history.splice(i, 1);
				return false;
			}	
		});
        _history.unshift(hashObj);
		
    }

    //捕获section页的事件
    var _catchSectionEvent = function(options){
        if(!sectionEventCache[options.tag]){
            sectionEventCache[options.tag] = {};
        } 

        if(prevSectionEvent.onReady != app.section.onReady){
            sectionEventCache[options.tag].onReady = prevSectionEvent.onReady = app.section.onReady;
        } 

        if(prevSectionEvent.onLoad != app.section.onLoad){
            sectionEventCache[options.tag].onLoad = prevSectionEvent.onLoad = app.section.onLoad;
        } 

        if(prevSectionEvent.onBack != app.section.onBack){
            sectionEventCache[options.tag].onBack = prevSectionEvent.onBack = app.section.onBack;
        } 
    }
    
	/*
     * 加载section模板
     * @param {string} hash信息
     * @param {string} url参数
     */
    var loadSectionTpl = function(options ,callback){

    	var url = options.url,
    	    params = options.params;

        if(ui.settings.showPageLoading){
            if(typeof Cordova == 'undefined') ui.showMask(ui.settings.showPageLoadingText, ui.settings.showPageLoadingIcon); 
            else app.progress.start('',ui.settings.showPageLoadingText); 
        }

        loadContent(url,params,function(html){

            //$(options.tag).remove();//主要是为了ui.refresh()  
            //添加到dom树中
            var $h = $(html);
            $('#section_container').append($h);
 
            $h.filter("section").addClass('active').attr("id", options.tag); //不然aside块也是active
            _catchSectionEvent(options);
            _currentSection = options;
            //$h.trigger('pageReady', [options]); // 页面DOM加载完成
            sectionEventCache[options.tag].onReady && sectionEventCache[options.tag].onReady(options);

            $h.uiwidget(); //初始化

            if(ui.settings.showPageLoading){
                if(typeof Cordova == 'undefined') ui.hideMask();
                else app.progress.stop();
            }
            callback();
            $h = null;
        });
    }

    var _removeHistoryDom = function(tag){
		_removeAside($(tag)); 
		 
        $(tag).remove();  
        $("#section_container>*").filter("script,style").remove();
    }
	
	function _removeAside($obj){
		var prev = $obj.prev("aside");
		if(prev.length > 0){
			_removeAside(prev);
			prev.remove();
		}   
	}

    /*
     * 加载文档片段
     * @param url
     */
    var loadContent = function(url,param,callback){
        return $.ajax({
                url : url + "?t=" + (new Date()).valueOf() , //加上时间戳，不缓存
                timeout : 20000,
                data : {},
                success : function(html){
                    if(html){
                        callback && callback(html);                       
                    } else{
                        _loadContentError({status:4}); //android下请求不存在的页面是success回调，-_-|||
                    }

                },
                error : function(e) {
                    _loadContentError(e);
                }
        });
    }

    var _loadContentError = function(e){

        ui.isPageSwitching = false;
        var errorType = (e.status + "").substring(0,1), errorMsg;
   
        switch(errorType){
            case '4' : 
                errorMsg = "页面不存在";
            break;
            case '5' :
                errorMsg = "服务器错误";
            break;
            case '3' : 
                errorMsg = "页面已重定向";
            break;
        }

        if( ui.settings.showPageLoading){
            if(typeof Cordova == 'undefined'){
                $("#bingotouch_popup").find("i,p").remove();
                $("#bingotouch_popup").prepend('<i class="icon icon-cancel"></i><p>' + errorMsg + '</p>');   
            } else{
               app.progress.stop();
               ui.showMask(errorMsg, "icon-cancel");  
            }

        } else {
            ui.showMask(errorMsg, "icon-cancel");  
        }

    }
    

    //保存页面状态
    //TODO:表单页面的状态并没有处理
    var _savePageStatus = function(tag){

        var iscrolls = GC.get(tag, "iScroll");

        for (var i = iscrolls.length - 1; i >= 0; i -= 1) {
           iscrolls[i].animating = true;
        }
 
    }

    //恢复页面状态
    //TODO:表单页面的状态并没有处理
    var _resumePageStatus = function(tag){
       
        var iscrolls = GC.get(tag, "iScroll");

        //恢复自动刷新
        for (var i = iscrolls.length - 1; i >= 0; i -= 1) {
           iscrolls[i].animating = false;
        }
    }


	return {
        history : _history, //页面堆栈
		init : init,
		load : load,
        refresh : refresh,
        back : back
	};

})();
 


 // //另一中页面事件声明的方式, 不过现在没启用
// ui.addPageEvent(sectionId ,function(){
//  //页面DOM加载完成
//  //页面信息
//  /*
//      options
//      tag: "#popup_section" 页面最外层容器的css选择器
//      url: 页面url
//      params : 页面传的参数 
//   */
//     this.pageReady = function(event, options){
//      // console.log(event);
//      // console.log(options);
//     }

//     //页面uiwidget完成
//     this.pageLoad = function(){

        
//     }

//     //页面后退
//     this.pageBack = function(){
//     }
// });