;ui.Utils = {
    setViewPort: function () {
        //android viewport
        var viewport = "";
        var userAgent = navigator.userAgent.toLowerCase();

        if (/android (\d+\.\d+)/.test(userAgent)) {
            viewport ="width=device-width,initial-scale=1,user-scalable=no,target-densitydpi =240";
        } else {
          	viewport ="width=device-width,initial-scale=0.666666,user-scalable=no";
        }
        //add view
        if ($("meta[name='viewport']").length > 0) {
            $("meta[name='viewport']").attr("content", viewport);
        } else {
            var element = document.createElement('meta');
            element.name = "viewport";
            element.content = viewport;
            var head = document.getElementsByTagName('head')[0];
            head.appendChild(element);
			
        }
    },
    parseHash : function(hash){
        var tag,query,param={};
        var arr = hash.split('?');
        tag = arr[0];
        if(arr.length>1){
            var seg,s;
            query = arr[1];
            seg = query.split('&');
            for(var i=0;i<seg.length;i++){
                if(!seg[i])continue;
                s = seg[i].split('=');
                param[s[0]] = s[1];
            }
        }
        return {
            hash : hash,
            tag : tag,
            query : query,
            param : param
        }
    },
    //Color
	//将hex颜色值str转化成rgb数组  
    HexToRgb : function (str) {  
        var r = /^\#?[0-9a-fA-Z]{6}$/;  
        //test方法检查在字符串中是否存在一个模式，如果存在则返回true，否则返回false  
        if (!r.test(str)) return window.alert("输入错误的hex颜色值");  
        //replace替换查找的到的字符串  
        str = str.replace("#", "");  
        //match得到查询数组  
        var hxs = str.match(/../g);  
        for (var i = 0; i < 3; i++) hxs[i] = parseInt(hxs[i], 16);  
        return hxs;  
    },
    //将rgb颜色值为a,b,c转化成hex颜色值  
    RgbToHex : function (a, b, c) {  
        var r = /^\d{1,3}$/;  
        if (!r.test(a) || !r.test(b) || !r.test(c)) return window.alert("输入错误的rgb颜色值");  
        var hexs = [a.toString(16), b.toString(16), c.toString(16)];  
        for (var i = 0; i < 3; i++) if (hexs[i].length == 1) hexs[i] = "0" + hexs[i];  
        return "#" + hexs.join("");  
    },  
    //得到hex颜色值为color的加深颜色值，level为加深的程度，限0-1之间  
    getDarkColor : function (color, level) {  
        var r = /^\#?[0-9a-fA-Z]{6}$/;  
        if (!r.test(color)) return window.alert("输入错误的hex颜色值");  
        var rgbc = ui.Utils.HexToRgb(color);  
        //floor 向下取整  
        for (var i = 0; i < 3; i++) rgbc[i] = Math.floor(rgbc[i] * (1 - level));  
        return ui.Utils.RgbToHex(rgbc[0], rgbc[1], rgbc[2]);  
    },  
    //得到hex颜色值为color的减淡颜色值，level为减淡的程度，限0-1之间  
    getLightColor : function (color, level) {  
        var r = /^\#?[0-9a-fA-Z]{6}$/;  
        if (!r.test(color)) return window.alert("输入错误的hex颜色值");  
        var rgbc = ui.Utils.HexToRgb(color);  
        for (var i = 0; i < 3; i++) rgbc[i] = Math.floor((255 - rgbc[i]) * level + rgbc[i]);  
        return ui.Utils.RgbToHex(rgbc[0], rgbc[1], rgbc[2]);  
    },  
    //得到hex颜色值为color的web安全色  
    getWebSafeColor : function (color) {  
        var r = /^\#?[0-9a-fA-Z]{6}$/;  
        if (!r.test(color)) return window.alert("输入错误的hex颜色值");  
        var rgbc = ui.Utils.HexToRgb(color);  
        for (var i = 0; i < 3; i++) {  
            var q1 = Math.floor(rgbc[i] / 51) * 51;  
            //ceil向上取整  
            var q2 = Math.ceil(rgbc[i] / 51) * 51;  
            //abs绝对值  
            if (Math.abs(q1 - rgbc[i]) <= Math.abs(q2 - rgbc[i])) rgbc[i] = q1;  
            else rgbc[i] = q2;  
        }  
        return ui.Utils.RgbToHex(rgbc[0], rgbc[1], rgbc[2]);  
    },
    //获取url参数
    getUrlQueryString : function (item){
         var sValue=location.search.match(new RegExp("[\?\&]"+item+"=([^\&]*)(\&?)","i"))
         return sValue?sValue[1]:sValue
    },
    getDefaultDatePickerValue : function(type, value, format){
		var dateGroup = [];
		
		var nowDate = {};
		if (type == 'date' || type == 'wheeldate') {
			dateGroup = value.split('-');
			if(format){
			 	if(format.indexOf('y') > -1)   
			 		nowDate.year = dateGroup.shift();
			 	else
			 		nowDate.year = 2016;
			 	if(format.indexOf('m') > -1)   
			 		nowDate.month = dateGroup.shift();
			 	else
			 		nowDate.month = 1; 
			 	if(format.indexOf('d') > -1)   
			 		nowDate.day = dateGroup.shift();
			 	else
			 		nowDate.day = 1;
			} else {
				nowDate.year = dateGroup[0];
				nowDate.month = dateGroup[1];
				nowDate.day = dateGroup[2];	
			}
		} else {
			dateGroup = value.split(':');
			nowDate.hour = dateGroup[0];
			nowDate.minute = dateGroup[1];
		}
		return nowDate;
    },
    getFormatDatePickerValue : function(type, res, format){
   
    	if(format){
    		format = format.toLowerCase();
	       	var full = [];    	
			if (type == 'date' || type == 'wheeldate') {
			 	if(format.indexOf('y') > -1) full.push(res.year);
			 	if(format.indexOf('m') > -1) full.push(res.month);
			 	if(format.indexOf('d') > -1) full.push(res.day);
			 	return full.join("-");
			} 		
    	} else {
    		return res.full;
    	}
		
    }
}


/*
* Object String extend
*/
String.prototype.startWith = function (str) {
    var reg = new RegExp("^" + str);
    return reg.test(this);
}

String.prototype.endWith = function (str) {
    var reg = new RegExp(str + "$");
    return reg.test(this);
}

String.prototype.getQueryString = function (name) { //name 是URL的参数名字 
    var reg = new RegExp("(^|&|\\?)" + name + "=([^&]*)(&|$)"), r;
    if (r = this.match(reg)) return (unescape(r[2]) || "").split("#")[0]; return null;
};


//表单数据 toJSON
/**
@class ui
*/
/**
  将表单数据封装成为一个JSON对象 ,
  <span><font color='red'>不论是BingoTouch定义的表单元素还是传统表单元素，都能被封装。</font></span>
  @method $(selector).toJSON(justValue)
  @param justValue {boolean} 只封装值  ⇒ true |　false
  @return {JSON对象} 表单数据
  @example
	HTML:
		<div id="test">
			<div  id="btswitch" name="switchB" class="BTCheck_OFF" data-role="BTSwitch" ></div>
			<div data-role="BTCheck" name="csex" value="girl">女</div>
			<div data-role="BTCheck" name="csex" value="boy">男</div>
			<div data-role="BTCheck" name="csex" value="rao">中</div>
			<div data-role="BTRadio" name="rsex"  value="boy">男</div>
			<div data-role="BTRadio" name="rsex"  value="girl">女</div>
			<div id="BTSelect" data-role="BTSelect"  name="selectsex" data='[{"value":"female","label":"女"},{"value":"male","label":"男"}]' title="请选择性别"><span>请选择性别</span></div>
			<div id="BTTime" data-role="BTSelect"  name="time" data='{"hour":16,"minute":29,"full":"16:29"}' type="time"><span>请选择时间</span></div>
		</div>
	JS:
		$("#test").toJSON(false);
		//return JSON对象如下
		{ 
		"csex":[{"value":"girl","label":"女"},{"value":"boy","label":"男"}],
		"rsex":{"value":"boy","label":"男"},
		"switchB":true,
		"selectsex":{"value":"female","label":"女"},
		"time":"10:4"
		}
		$("#test").toJSON(true);
		//return JSON对象如下
		{ 
		"csex":["girl","boy"],
		"rsex":"boy",
		"switchB":true,
		"selectsex":"female",
		"time":"10:4"
		}
*/
$.fn.toJSON= function(justValue){
	//BingoTouch定义表单元素
	var selector =$(this);
   	var result={};
	$("[data-role='BTCheck']",selector).each(function(){
	    var $obj = $(this);
		var name = $obj.attr("name"), val =$obj.btcheck("val")[0];
		if(name!=null&&val!=null){
			result[name] = result[name]||[] ;
			if(justValue){ result[name].push(val.value) ; }
			else{ result[name].push(val) ; } 
		}
    }) ;
	$("[data-role='BTRadio']",selector).each(function(){
	    var $obj = $(this);
		var name = $obj.attr("name"), val =$obj.btradio("val");
		if(name!=null&&val!=null){
			if(justValue){ result[name] = val.value; }
			else{ result[name] =val; } 
		}
    }) ;
	$("[data-role='BTSwitch']",selector).each(function(){
	    var $obj = $(this);
		var name = $obj.attr("name"), val =$obj.btswitch("val") ;
		if(name!=null){
			result[name] = val;
		}
    }) ;
	$("[data-role='BTSelect']",selector).each(function(){
	    var $obj = $(this);
		var type = $obj.attr("type"),name = $obj.attr("name"),val;
		if(type=='date'||type=='time'){
		   val =$obj.btdatepicker("val") ;
		}
		else{
		   val =$obj.btselect("val") ;
		}
		if(name!=null){
			if(justValue){ result[name] = val.value; }
			else{ result[name] =val; } 
		}
    }) ;
	$('.dropdown > div[data-role="BTButton"]',selector).each(function(){
	    var $obj = $(this);
		var name = $obj.attr("name"), val =$obj.btdropdown("val");
		if(name!=null){
			result[name] =val;
		}
    }) ;
	//传统表单元素
	$("input",selector).each(function(){
	   var $obj = $(this);
	   var type = $obj.attr('type'),name= $obj.attr("name");
	   if(type=='text'||type=='password'){
		  result[name] = $obj.attr('value');
	   }
	   else if( type =='checkbox'){
		  if($obj.attr("checked")){
		  	 result[name] = result[name]||[] ;
		     result[name].push($obj.attr("value")) ;	
		  }		  
	   }
	   else if( type=='radio') {
		  if($obj.attr("checked")){
		  	 result[name] = $obj.attr("value") ;
		  }		   
	   }
	});
	$("textarea",selector).each(function(){
	    var $obj = $(this);
		result[$obj.attr("name")] = $obj.attr('value');
	});
	$("select",selector).each(function(){
	    var $obj = $(this);
		result[$obj.attr("name")] = $obj.attr('value');
	});
    return result;	
}
 





