;
(function (window) {
    window.app.database = window.app.database || {};

    //打开数据库，如果不存在则会创建
    app.database.open = function (name, version, size, success, fail) {
        if (window.devicePlatform == "iOS") {
            //iOS下回调才能拿到数据
            return Cordova.exec(success, fail, "SqlitePlugin", "createDatabase", [name, version, size]);
        } else if (window.devicePlatform == "android") {
            success(window.openDatabase(name, version, name, size));
        }
    }

    if (window.devicePlatform == "iOS") {
        /**
        执行sql: create,drop,insert,update,delete.
        支持批量
        @method app.database.executeNonQuery
        @param database {Object} open的数据库
        @param sql {String | Array } sql （可单条或批量）
        @param success {Function} 成功回调 PS：成功回调没有result参数
        @param fail{Function} 失败回调
        @example
        app.database.executeNonQuery(testDatabase, [
        'DROP TABLE IF EXISTS DEMO',
        'CREATE TABLE IF NOT EXISTS DEMO (id unique, data)',
        'INSERT INTO DEMO (id, data) VALUES (1, "First row")',
        'INSERT INTO DEMO (id, data) VALUES (2, "Second row")'
        ],function(){
        },function(res){
        });
        */
        app.database.executeNonQuery = function (database, sql, success, fail) {
            success = success || function () { }
            fail = fail || function (error) { app.alert(error); }

            if (typeof sql == "string") {
                sql = new Array(sql);
            }

            Cordova.exec(success, fail, "SqlitePlugin", "excuteSql", [database, sql]);
        }

        /*
        执行查询
        @method app.database.executeQuery
        @param database {Object} open的数据库
        @param sql {String} sql
        @param success {Function} 成功回调
        @param fail{Function} 失败回调
        @example
        app.database.executeQuery(testDatabase ,'select * from DEMO',function(tx, results){
        },function(res){
        });
        */
        app.database.executeQuery = function (database, sql, success, fail) {
            var successCallback = function (results) {
                results = eval('(' + results + ')');
                var data = {
                    rows: {
                        length: results.length,
                        item: function (index) {
                            return results[index];
                        }
                    }
                }
                success(database, data);
            }
            fail = fail || function (error) { app.alert(error); }
            Cordova.exec(successCallback, fail, "SqlitePlugin", "querySql", [database, sql]);
        }
    }


})(window);
