window.app=window.app||{};
  /**
  运行时定时任务接口
  @class app.timetask
  */
  window.app.timetask=window.app.timetask||{}

  /**
  开启一个定时任务
  @method app.timetask.start
  @static
  @param params {Object} 启动定时任务需要的参数
     id: 定时任务id，id重复不能重复
     taskAction: 定时执行的动作，这里可以是方法名或者匿名方法
     maxCount: 任务最多执行的次数，不传默认1w次
     loopTime: 任务执行间隔时间，单位是毫秒
     isImmediate: 是否立刻执行，默认不立刻执行，loopTime 毫秒后才执行
     callback: 回调函数，返回json对象。如｛id:"",status:"",desc:""｝ 
  */
  app.timetask.start=function(params){
    params=params||{};
    params.id=params.id||"";
    params.taskAction=params.taskAction||"";
    params.maxCount=params.maxCount||10000;//默认执行1w次
    params.loopTime=params.loopTime||1000; //默认1s 执行一次
    params.isImmediate=params.isImmediate||false; //是否立刻执行

    if(params.id==""){
      app.alert("任务id不能为空!");
      return;
    }
    if(params.taskAction==""){
      app.alert("任务动作不能为空!");
      return;
    }
        var nativeCallback=function(result){
            params.callback(app.utils.toJSON(result));
        }
    Cordova.exec(nativeCallback, null, "TimeTask", "taskStart", [params]);
  }

  /**
  结束一个定时任务
  @method app.timetask.stop
  @static
  @param id {String} 任务id
  @param callback {function} 回调函，数返回json对象。如｛id:"",status:"",desc:""｝ 
  */
  app.timetask.stop=function(id,callback){
    id=id||"";
    if(id==""){
      app.alert("任务id不能为空!");
      return;
    }
        var nativeCallback=function(result){
            callback(app.utils.toJSON(result));
        }
    Cordova.exec(nativeCallback, null, "TimeTask", "taskStop", [id]);
  }